#define G_LOG_DOMAIN "boilerplate-dark-theme"

#include "boilerplate-dark-theme.h"

#include "boilerplate-application.h"
#include "boilerplate-plugins-activatable.h"

#include <gtk/gtk.h>
#include <libpeas/peas.h>

struct _BoilerplatePluginDarkTheme
{
    PeasExtensionBase parent;
};

G_DEFINE_DYNAMIC_TYPE_EXTENDED (BoilerplatePluginDarkTheme,
                                boilerplate_plugin_dark_theme,
                                PEAS_TYPE_EXTENSION_BASE,
                                0,
                                G_IMPLEMENT_INTERFACE_DYNAMIC (BOILERPLATE_TYPE_PLUGINS_ACTIVATABLE,
                                                               boilerplate_plugins_activatable_iface_init))

static void
boilerplate_plugin_dark_theme_activate (BoilerplatePluginsActivatable *activatable)
{
    g_object_set (gtk_settings_get_default (),
                  "gtk-application-prefer-dark-theme", TRUE,
                  NULL);
}

static void
boilerplate_plugin_dark_theme_deactivate (BoilerplatePluginsActivatable *activatable)
{
    g_object_set (gtk_settings_get_default (),
                  "gtk-application-prefer-dark-theme", FALSE,
                  NULL);
}

static void
boilerplate_plugins_activatable_iface_init (BoilerplatePluginsActivatableInterface *iface)
{
    iface->activate = boilerplate_plugin_dark_theme_activate;
    iface->deactivate = boilerplate_plugin_dark_theme_deactivate;
}

static void
boilerplate_plugin_dark_theme_class_finalize (BoilerplatePluginDarkThemeClass *klass)
{
}

static void
boilerplate_plugin_dark_theme_class_init (BoilerplatePluginDarkThemeClass *klass)
{
}

static void
boilerplate_plugin_dark_theme_init (BoilerplatePluginDarkTheme *self)
{
}

G_MODULE_EXPORT void
boilerplate_plugin_dark_theme_register_types (PeasObjectModule *module)
{
    boilerplate_plugin_dark_theme_register_type (G_TYPE_MODULE (module));

    peas_object_module_register_extension_type (module,
                                                BOILERPLATE_TYPE_PLUGINS_ACTIVATABLE,
                                                BOILERPLATE_TYPE_PLUGIN_DARK_THEME);
}

